#ifndef QOP_MDWF_0bd50d0caeec4311a0d7c183032c43c2
# define QOP_MDWF_0bd50d0caeec4311a0d7c183032c43c2
  #define QOP_MDWF_DIM 4
  #define QOP_MDWF_FERMION_DIM 4
  #define QOP_MDWF_PROJECTED_FERMION_DIM 2
  #define QOP_MDWF_COLORS 3
  struct QOP_MDWF_State;
  struct QOP_MDWF_Parameters;
  struct QOP_F3_MDWF_Gauge;
  struct QOP_D3_MDWF_Gauge;
  struct QOP_F3_MDWF_Fermion;
  struct QOP_D3_MDWF_Fermion;
  struct QOP_F3_MDWF_HalfFermion;
  struct QOP_D3_MDWF_HalfFermion;
  struct QOP_F3_MDWF_VectorFermion;
  struct QOP_D3_MDWF_VectorFermion;
  enum {
     QOP_MDWF_LOG_NONE = 0,
     QOP_MDWF_LOG_CG_RESIDUAL = 1,
     QOP_MDWF_LOG_TRUE_RESIDUAL = 2,
     QOP_MDWF_LOG_DIRAC_RESIDUAL = 4,
     QOP_MDWF_FINAL_CG_RESIDUAL = 8,
     QOP_MDWF_FINAL_DIRAC_RESIDUAL = 16,
     QOP_MDWF_LOG_EVERYTHING = 31
  };
  const char *QOP_MDWF_version(void);
  int QOP_MDWF_performance(double *time_sec,
                           long long *flops,
                           long long *sent,
                           long long *receive,
                           struct QOP_MDWF_State *state);
  int QOP_MDWF_init(struct QOP_MDWF_State **state_ptr,
                    const int lattice[QOP_MDWF_DIM + 1],
                    const int network[QOP_MDWF_DIM],
                    const int node[QOP_MDWF_DIM],
                    int master_p,
                    void (*sublattice)(int lo[],
                                       int hi[],
                                       const int node[],
                                       void *env),
                    void *env);
  void QOP_MDWF_fini(struct QOP_MDWF_State **state_ptr);
  const char *QOP_MDWF_error(struct QOP_MDWF_State *state);
  int QOP_MDWF_set_generic(struct QOP_MDWF_Parameters **param_ptr,
                           struct QOP_MDWF_State *state,
                           const double b_5[],
                           const double c_5[],
                           double M_5,
                           double m);
  int QOP_MDWF_set_Moebius(struct QOP_MDWF_Parameters **param_ptr,
                           struct QOP_MDWF_State *state,
                           const double b_5[],
                           double kappa,
                           double M_5,
                           double m);
  int QOP_MDWF_set_Shamir(struct QOP_MDWF_Parameters **param_ptr,
                          struct QOP_MDWF_State *state,
                          double a_5,
                          double M_5,
                          double m);
  int QOP_MDWF_set_Borichi(struct QOP_MDWF_Parameters **param_ptr,
                           struct QOP_MDWF_State *state,
                           double a_5,
                           double M_5,
                           double m);
  int QOP_MDWF_set_Chiu(struct QOP_MDWF_Parameters **param_ptr,
                        struct QOP_MDWF_State *state,
                        const double a_5[],
                        double M_5,
                        double m);
  void QOP_MDWF_free_parameters(struct QOP_MDWF_Parameters **param_ptr);
  int QOP_F3_MDWF_import_gauge(struct QOP_F3_MDWF_Gauge **gauge_ptr,
                               struct QOP_MDWF_State *state,
                               double (*reader)(int dir,
                                                const int pos[4],
                                                int a,
                                                int b,
                                                int re_im,
                                                void *env),
                               void *env);
  int QOP_D3_MDWF_import_gauge(struct QOP_D3_MDWF_Gauge **gauge_ptr,
                               struct QOP_MDWF_State *state,
                               double (*reader)(int dir,
                                                const int pos[4],
                                                int a,
                                                int b,
                                                int re_im,
                                                void *env),
                               void *env);
  void QOP_F3_MDWF_free_gauge(struct QOP_F3_MDWF_Gauge **gauge_ptr);
  void QOP_D3_MDWF_free_gauge(struct QOP_D3_MDWF_Gauge **gauge_ptr);
  int QOP_F3_MDWF_import_fermion(struct QOP_F3_MDWF_Fermion **fermion_ptr,
                                 struct QOP_MDWF_State *state,
                                 double (*reader)(const int pos[5],
                                                  int color,
                                                  int dirac,
                                                  int re_im,
                                                  void *env),
                                 void *env);
  int QOP_D3_MDWF_import_fermion(struct QOP_D3_MDWF_Fermion **fermion_ptr,
                                 struct QOP_MDWF_State *state,
                                 double (*reader)(const int pos[5],
                                                  int color,
                                                  int dirac,
                                                  int re_im,
                                                  void *env),
                                 void *env);
  int QOP_F3_MDWF_allocate_fermion(struct QOP_F3_MDWF_Fermion **fermion_ptr,
                                   struct QOP_MDWF_State *state);
  int QOP_D3_MDWF_allocate_fermion(struct QOP_D3_MDWF_Fermion **fermion_ptr,
                                   struct QOP_MDWF_State *state);
  int QOP_F3_MDWF_export_fermion(void (*writer)(const int pos[5],
                                                int color,
                                                int dirac,
                                                int re_im,
                                                double value,
                                                void *env),
                                 void *env,
                                 const struct QOP_F3_MDWF_Fermion *fermion);
  int QOP_D3_MDWF_export_fermion(void (*writer)(const int pos[5],
                                                int color,
                                                int dirac,
                                                int re_im,
                                                double value,
                                                void *env),
                                 void *env,
                                 const struct QOP_D3_MDWF_Fermion *fermion);
  void QOP_F3_MDWF_free_fermion(struct QOP_F3_MDWF_Fermion **fermion_ptr);
  void QOP_D3_MDWF_free_fermion(struct QOP_D3_MDWF_Fermion **fermion_ptr);
  int QOP_F3_MDWF_import_half_fermion(struct QOP_F3_MDWF_HalfFermion **hfermion_ptr,
                                      struct QOP_MDWF_State *state,
                                      double (*reader)(const int pos[5],
                                                       int color,
                                                       int dirac,
                                                       int re_im,
                                                       void *env),
                                      void *env);
  int QOP_D3_MDWF_import_half_fermion(struct QOP_D3_MDWF_HalfFermion **hfermion_ptr,
                                      struct QOP_MDWF_State *state,
                                      double (*reader)(const int pos[5],
                                                       int color,
                                                       int dirac,
                                                       int re_im,
                                                       void *env),
                                      void *env);
  int QOP_F3_MDWF_allocate_half_fermion(struct QOP_F3_MDWF_HalfFermion **hfermion_ptr,
                                        struct QOP_MDWF_State *state);
  int QOP_D3_MDWF_allocate_half_fermion(struct QOP_D3_MDWF_HalfFermion **hfermion_ptr,
                                        struct QOP_MDWF_State *state);
  int QOP_F3_MDWF_export_half_fermion(void (*writer)(const int pos[5],
                                                     int color,
                                                     int dirac,
                                                     int re_im,
                                                     double value,
                                                     void *env),
                                     void *env,
                                     const struct QOP_F3_MDWF_HalfFermion *hfermion);
  int QOP_D3_MDWF_export_half_fermion(void (*writer)(const int pos[5],
                                                     int color,
                                                     int dirac,
                                                     int re_im,
                                                     double value,
                                                     void *env),
                                     void *env,
                                     const struct QOP_D3_MDWF_HalfFermion *hfermion);
  void QOP_F3_MDWF_free_half_fermion(struct QOP_F3_MDWF_HalfFermion **hfermion_ptr);
  void QOP_D3_MDWF_free_half_fermion(struct QOP_D3_MDWF_HalfFermion **hfermion_ptr);
  int QOP_F3_MDWF_allocate_vector_fermion(struct QOP_F3_MDWF_VectorFermion **vf_ptr,
                                          struct QOP_MDWF_State *state,
                                          int n);
  int QOP_D3_MDWF_allocate_vector_fermion(struct QOP_D3_MDWF_VectorFermion **vf_ptr,
                                         struct QOP_MDWF_State *state,
                                         int n);
  void QOP_F3_MDWF_free_vector_fermion(struct QOP_F3_MDWF_VectorFermion **vf_ptr);
  void QOP_D3_MDWF_free_vector_fermion(struct QOP_D3_MDWF_VectorFermion **vf_ptr);
  int QOP_F3_MDWF_get_vector_fermion(struct QOP_F3_MDWF_HalfFermion *hf,
                                     const struct QOP_F3_MDWF_VectorFermion *vf,
                                     int index);
  int QOP_D3_MDWF_get_vector_fermion(struct QOP_D3_MDWF_HalfFermion *hf,
                                     const struct QOP_D3_MDWF_VectorFermion *vf,
                                     int index);
  int QOP_F3_MDWF_put_vector_fermion(struct QOP_F3_MDWF_VectorFermion *vf,
                                     int index,
                                     const struct QOP_F3_MDWF_HalfFermion *hf);
  int QOP_D3_MDWF_put_vector_fermion(struct QOP_D3_MDWF_VectorFermion *vf,
                                     int index,
                                     const struct QOP_D3_MDWF_HalfFermion *hf);
  int QOP_F3_MDWF_DDW_operator(struct QOP_F3_MDWF_Fermion *result,
                               const struct QOP_MDWF_Parameters *params,
                               const struct QOP_F3_MDWF_Gauge *gauge,
                               const struct QOP_F3_MDWF_Fermion *fermion);
  int QOP_D3_MDWF_DDW_operator(struct QOP_D3_MDWF_Fermion *result,
                               const struct QOP_MDWF_Parameters *params,
                               const struct QOP_D3_MDWF_Gauge *gauge,
                               const struct QOP_D3_MDWF_Fermion *fermion);
  int QOP_F3_MDWF_DDW_operator_conjugated(struct QOP_F3_MDWF_Fermion *result,
                                          const struct QOP_MDWF_Parameters *params,
                                          const struct QOP_F3_MDWF_Gauge *gauge,
                                          const struct QOP_F3_MDWF_Fermion *fermion);
  int QOP_D3_MDWF_DDW_operator_conjugated(struct QOP_D3_MDWF_Fermion *result,
                                          const struct QOP_MDWF_Parameters *params,
                                          const struct QOP_D3_MDWF_Gauge *gauge,
                                          const struct QOP_D3_MDWF_Fermion *fermion);
  int QOP_F3_MDWF_M_operator(struct QOP_F3_MDWF_HalfFermion *result,
                             const struct QOP_MDWF_Parameters *params,
                             const struct QOP_F3_MDWF_Gauge *gauge,
                             const struct QOP_F3_MDWF_HalfFermion *fermion);
  int QOP_D3_MDWF_M_operator(struct QOP_D3_MDWF_HalfFermion *result,
                             const struct QOP_MDWF_Parameters *params,
                             const struct QOP_D3_MDWF_Gauge *gauge,
                             const struct QOP_D3_MDWF_HalfFermion *fermion);
  int QOP_F3_MDWF_M_operator_conjugated(struct QOP_F3_MDWF_HalfFermion *result,
                                        const struct QOP_MDWF_Parameters *params,
                                        const struct QOP_F3_MDWF_Gauge *gauge,
                                        const struct QOP_F3_MDWF_HalfFermion *fermion);
  int QOP_D3_MDWF_M_operator_conjugated(struct QOP_D3_MDWF_HalfFermion *result,
                                        const struct QOP_MDWF_Parameters *params,
                                        const struct QOP_D3_MDWF_Gauge *gauge,
                                        const struct QOP_D3_MDWF_HalfFermion *fermion);
  int QOP_F3_MDWF_DDW_CG(struct QOP_F3_MDWF_Fermion *result,
                         int *out_iterations,
                         double *out_epsilon,
                         const struct QOP_MDWF_Parameters *params,
                         const struct QOP_F3_MDWF_Fermion *chi_0,
                         const struct QOP_F3_MDWF_Gauge *gauge,
                         const struct QOP_F3_MDWF_Fermion *rhs,
                         int max_iteration,
                         double epsilon,
                         unsigned int options);
  int QOP_D3_MDWF_DDW_CG(struct QOP_D3_MDWF_Fermion *result,
                         int *out_iterations,
                         double *out_epsilon,
                         const struct QOP_MDWF_Parameters *params,
                         const struct QOP_D3_MDWF_Fermion *x_0,
                         const struct QOP_D3_MDWF_Gauge *gauge,
                         const struct QOP_D3_MDWF_Fermion *rhs,
                         int max_iteration,
                         double epsilon,
                         unsigned int options);
  int QOP_F3_MDWF_MxM_CG(struct QOP_F3_MDWF_HalfFermion *result,
                         int *out_iterations,
                         double *out_epsilon,
                         const struct QOP_MDWF_Parameters *params,
                         const struct QOP_F3_MDWF_Gauge *gauge,
                         const struct QOP_F3_MDWF_HalfFermion *rhs,
                         int max_iteration,
                         double epsilon,
                         unsigned int options);
  int QOP_D3_MDWF_MxM_CG(struct QOP_D3_MDWF_HalfFermion *result,
                         int *out_iterations,
                         double *out_epsilon,
                         const struct QOP_MDWF_Parameters *params,
                         const struct QOP_D3_MDWF_Gauge *gauge,
                         const struct QOP_D3_MDWF_HalfFermion *rhs,
                         int max_iteration,
                         double epsilon,
                         unsigned int options);
  int QOP_F3_MDWF_MxM_SCG(struct QOP_F3_MDWF_VectorFermion *vector_result,
                          struct QOP_F3_MDWF_HalfFermion *scalar_result,
                          int *out_iterations,
                          double *out_epsilon,
                          const struct QOP_MDWF_Parameters *params,
                          const double shift[],
                          const struct QOP_F3_MDWF_Gauge *gauge,
                          const struct QOP_F3_MDWF_HalfFermion *rhs,
                          int max_iterations,
                          double min_epsilon,
                          unsigned int options);
  int QOP_D3_MDWF_MxM_SCG(struct QOP_D3_MDWF_VectorFermion *vector_result,
                          struct QOP_D3_MDWF_HalfFermion *scalar_result,
                          int *out_iterations,
                          double *out_epsilon,
                          const struct QOP_MDWF_Parameters *params,
                          const double shift[],
                          const struct QOP_D3_MDWF_Gauge *gauge,
                          const struct QOP_D3_MDWF_HalfFermion *rhs,
                          int max_iterations,
                          double min_epsilon,
                          unsigned int options);
  int QOP_F3_MDWF_madd_fermion(struct QOP_F3_MDWF_Fermion *r,
                               const struct QOP_F3_MDWF_Fermion *a,
                               double alpha,
                               const struct QOP_F3_MDWF_Fermion *b);
  int QOP_D3_MDWF_madd_fermion(struct QOP_D3_MDWF_Fermion *r,
                               const struct QOP_D3_MDWF_Fermion *a,
                               double alpha,
                               const struct QOP_D3_MDWF_Fermion *b);
  int QOP_F3_MDWF_madd_half_fermion(struct QOP_F3_MDWF_HalfFermion *r,
                                    const struct QOP_F3_MDWF_HalfFermion *a,
                                    double alpha,
                                    const struct QOP_F3_MDWF_HalfFermion *b);
  int QOP_D3_MDWF_madd_half_fermion(struct QOP_D3_MDWF_HalfFermion *r,
                                    const struct QOP_D3_MDWF_HalfFermion *a,
                                    double alpha,
                                    const struct QOP_D3_MDWF_HalfFermion *b);
  int QOP_F3_MDWF_dot_fermion(double *r_re,
                              double *r_im,
                              const struct QOP_F3_MDWF_Fermion *a,
                              const struct QOP_F3_MDWF_Fermion *b);
  int QOP_D3_MDWF_dot_fermion(double *r_re,
                              double *r_im,
                              const struct QOP_D3_MDWF_Fermion *a,
                              const struct QOP_D3_MDWF_Fermion *b);
  int QOP_F3_MDWF_dot_half_fermion(double *r_re,
                                   double *r_im,
                                   const struct QOP_F3_MDWF_HalfFermion *a,
                                   const struct QOP_F3_MDWF_HalfFermion *b);
  int QOP_D3_MDWF_dot_half_fermion(double *r_re,
                                   double *r_im,
                                   const struct QOP_D3_MDWF_HalfFermion *a,
                                   const struct QOP_D3_MDWF_HalfFermion *b);
  int QOP_F3_MDWF_norm2_fermion(double *r,
                                const struct QOP_F3_MDWF_Fermion *a);
  int QOP_D3_MDWF_norm2_fermion(double *r_re,
                                const struct QOP_D3_MDWF_Fermion *a);
  int QOP_F3_MDWF_norm2_half_fermion(double *r_re,
                                     const struct QOP_F3_MDWF_HalfFermion *a);
  int QOP_D3_MDWF_norm2_half_fermion(double *r_re,
                                     const struct QOP_D3_MDWF_HalfFermion *a);
# if defined(QOP_MDWF_DEFAULT_PRECISION) && (QOP_MDWF_DEFAULT_PRECISION == 'F')
   #define QOP_MDWF_import_gauge QOP_F3_MDWF_import_gauge
   #define QOP_MDWF_free_gauge QOP_F3_MDWF_free_gauge
   #define QOP_MDWF_Gauge QOP_F3_MDWF_Gauge
   #define QOP_MDWF_import_fermion QOP_F3_MDWF_import_fermion
   #define QOP_MDWF_export_fermion QOP_F3_MDWF_export_fermion
   #define QOP_MDWF_allocate_fermion QOP_F3_MDWF_allocate_fermion
   #define QOP_MDWF_free_fermion QOP_F3_MDWF_free_fermion
   #define QOP_MDWF_Fermion QOP_F3_MDWF_Fermion
   #define QOP_MDWF_import_half_fermion QOP_F3_MDWF_import_half_fermion
   #define QOP_MDWF_export_half_fermion QOP_F3_MDWF_export_half_fermion
   #define QOP_MDWF_allocate_half_fermion QOP_F3_MDWF_allocate_half_fermion
   #define QOP_MDWF_free_half_fermion QOP_F3_MDWF_free_half_fermion
   #define QOP_MDWF_HalfFermion QOP_F3_MDWF_HalfFermion
   #define QOP_MDWF_allocate_vector_fermion QOP_F3_MDWF_allocate_vector_fermion
   #define QOP_MDWF_free_vector_fermion QOP_F3_MDWF_free_vector_fermion
   #define QOP_MDWF_get_vector_fermion QOP_F3_MDWF_get_vector_fermion
   #define QOP_MDWF_put_vector_fermion QOP_F3_MDWF_put_vector_fermion
   #define QOP_MDWF_VectorFermion QOP_F3_MDWF_VectorFermion
   #define QOP_MDWF_DDW_operator QOP_F3_MDWF_DDW_operator
   #define QOP_MDWF_DDW_operator_conjugated QOP_F3_MDWF_DDW_operator_conjugated
   #define QOP_MDWF_M_operator QOP_F3_MDWF_M_operator
   #define QOP_MDWF_M_operator_conjugated QOP_F3_MDWF_M_operator_conjugated
   #define QOP_MDWF_DDW_CG QOP_F3_MDWF_DDW_CG
   #define QOP_MDWF_MxM_CG QOP_F3_MDWF_MxM_CG
   #define QOP_MDWF_MxM_SCG QOP_F3_MDWF_MxM_SCG
   #define QOP_MDWF_madd_fermion QOP_F3_MDWF_madd_fermion
   #define QOP_MDWF_madd_half_fermion QOP_F3_MDWF_madd_half_fermion
   #define QOP_MDWF_dot_fermion QOP_F3_MDWF_dot_fermion
   #define QOP_MDWF_dot_half_fermion QOP_F3_MDWF_dot_half_fermion
   #define QOP_MDWF_norm2_fermion QOP_F3_MDWF_norm2_fermion
   #define QOP_MDWF_norm2_half_fermion QOP_F3_MDWF_norm2_half_fermion
# endif
# if defined(QOP_MDWF_DEFAULT_PRECISION) && (QOP_MDWF_DEFAULT_PRECISION == 'D')
    #define QOP_MDWF_import_gauge QOP_D3_MDWF_import_gauge
    #define QOP_MDWF_free_gauge QOP_D3_MDWF_free_gauge
    #define QOP_MDWF_Gauge QOP_D3_MDWF_Gauge
    #define QOP_MDWF_import_fermion QOP_D3_MDWF_import_fermion
    #define QOP_MDWF_export_fermion QOP_D3_MDWF_export_fermion
    #define QOP_MDWF_allocate_fermion QOP_D3_MDWF_allocate_fermion
    #define QOP_MDWF_free_fermion QOP_D3_MDWF_free_fermion
    #define QOP_MDWF_Fermion QOP_D3_MDWF_Fermion
    #define QOP_MDWF_import_half_fermion QOP_D3_MDWF_import_half_fermion
    #define QOP_MDWF_export_half_fermion QOP_D3_MDWF_export_half_fermion
    #define QOP_MDWF_allocate_half_fermion QOP_D3_MDWF_allocate_half_fermion
    #define QOP_MDWF_free_half_fermion QOP_D3_MDWF_free_half_fermion
    #define QOP_MDWF_HalfFermion QOP_D3_MDWF_HalfFermion
    #define QOP_MDWF_allocate_vector_fermion QOP_D3_MDWF_allocate_vector_fermion
    #define QOP_MDWF_free_vector_fermion QOP_D3_MDWF_free_vector_fermion
    #define QOP_MDWF_get_vector_fermion QOP_D3_MDWF_get_vector_fermion
    #define QOP_MDWF_put_vector_fermion QOP_D3_MDWF_put_vector_fermion
    #define QOP_MDWF_VectorFermion QOP_D3_MDWF_VectorFermion
    #define QOP_MDWF_DDW_operator QOP_D3_MDWF_DDW_operator
    #define QOP_MDWF_DDW_operator_conjugated QOP_D3_MDWF_DDW_operator_conjugated
    #define QOP_MDWF_M_operator QOP_D3_MDWF_M_operator
    #define QOP_MDWF_M_operator_conjugated QOP_D3_MDWF_M_operator_conjugated
    #define QOP_MDWF_DDW_CG QOP_D3_MDWF_DDW_CG
    #define QOP_MDWF_MxM_CG QOP_D3_MDWF_MxM_CG
    #define QOP_MDWF_MxM_SCG QOP_D3_MDWF_MxM_SCG
    #define QOP_MDWF_madd_fermion QOP_D3_MDWF_madd_fermion
    #define QOP_MDWF_madd_half_fermion QOP_D3_MDWF_madd_half_fermion
    #define QOP_MDWF_dot_fermion QOP_D3_MDWF_dot_fermion
    #define QOP_MDWF_dot_half_fermion QOP_D3_MDWF_dot_half_fermion
    #define QOP_MDWF_norm2_fermion QOP_D3_MDWF_norm2_fermion
    #define QOP_MDWF_norm2_half_fermion QOP_D3_MDWF_norm2_half_fermion
# endif
#endif
